#!/usr/bin/perl -w

use strict;
use XML::XPath;
use LWP::UserAgent;

my $news_url = 'http://search.cpan.org/recent.rdf';
my $request = HTTP::Request->new('GET', $news_url);
my $ua = LWP::UserAgent->new();
my $response = $ua->simple_request($request);

print qq*
<?xml version="1.0"?>
<vxml>
  <form id="greeting">
    <block>
      <audio>Please wait while I fetch the c pan news feed.</audio>
      <goto next="#headlines"/>
    </block>
  </form>   
*;
  
my $error = '';
my $xp;

if ($response->is_success) {
    eval {
        $xp = XML::XPath->new(xml => $response->content);
        $xp->find('/');
    };
    $error = $@ if $@;
}
else {
   $error = 'Remote server returned ' . $response->message();
}
 
if ($error) {
    print qq*
   <form id="headlines">
     <block>
       <audio>I'm sorry. The following error ocurred while fetching the headlines file. $error Please try again later.</audio>
       <disconnect/>
     </block>
  </form>
</vxml>  
    *;   
}
else { 
    print qq*
  <form id="headlines">
    <block>
      <audio>Fetch successful. The following modules have recently been up loaded to c pan.</audio>
    </block>
    <block>
    *;
 
    foreach my $news_item ($xp->findnodes('//item')) {
        print "<audio>" . $news_item->findvalue('title') . "</audio>\n";
    }
 
    print qq*
    <audio>  
      This completes the list of latest c pan up loads. Please call again tomorrow.
    </audio>
    <disconnect/>
    </block>
  </form>
</vxml>  
    *;   
}